%--------------Optimization 1----------------------------
disp('-------------------')
disp('Grid search method to solve the SOP')
disp('model: f=100*(x2-x1^2)^2+(1-x1)^2')
disp('initial values')
disp('x1_0=-1.9;x2_0=2')
disp('constraints:')
disp('-5 <= x1 <= 5')
disp('-5 <= x2 <= 5')
%----------------------------------------------------------
clear all 
close all 
format compact
%Initialization
x1_min=-5;x1_max=5;N_x1=100;
x1_array=linspace(x1_min,x1_max,N_x1);
x1_0=-1.9

x2_min=-5; x2_max=5;N_x2=100;
x2_array=linspace(x2_min,x2_max,N_x2);
x2_0=2

f_min=inf;
x1_opt=x1_0;
x2_opt=x2_0;

tic;

for k_x1=1:length(x1_array)
    x1=x1_array(k_x1);
    for k_x2=1:length(x2_array)
    x2=x2_array(k_x2);

    %objective function:
     f=100*(x2-x1^2)^2+(1-x1)^2;
    if f<=f_min,
        f_min=f;
        x1_opt=x1;
        x2_opt=x2;
    end
    end
end
%--------------------------------------------------
%Displaying the optimal solution:
disp('-------------------')
disp('Optimal solution:')
f_min
x1_opt
x2_opt
f_min=100*(x2_opt-x1_opt^2)^2+(1-x1_opt)^2



