%-------Optimization 3---------------------------------------------------
disp('Newtons method to solve the ROP problem')
disp('optimization problem:')
disp('min_x f(x)')
disp('s.t.')
disp('model: f=100*(x2-x1^2)^2+(1-x1)^2')

%----------------------------------------------------------
format compact
clear all
close all


x_k=[-1.9,2]';%Init
k=0;
N=100;%Preset max number of iterations
abs_df=1e-4;%Stopping criterion
for K=1:N-1
    %Gradient:
    G_k=[2*x_k(1) - 400*x_k(1)*x_k(2)+400*x_k(1)^3 - 2;
        -200*x_k(1)^2+200*x_k(2)];
    %Hessian:
    H_k=[1200*x_k(1)^2-400*x_k(2)+2,-400*x_k(1);
        -400*x_k(1),200];
    %Calculation of increment of x (used in x_kp1=x_k+dx_k):
    %dx_k=-inv(H_k)*G_k;
    %A numerically better alternative to calc dx_k:
    %dx_k is solution of following system of lin eqs: H_k*dx_k = -G_k
    %which can be effectively solved using '\' operator:
    dx_k=-H_k\G_k;
    
    x_kp1=x_k+dx_k;
    f_k=f(x_k);
    f_kp1=f(x_kp1);
    df=f_kp1-f_k;
    x_k=x_kp1;
    if abs(df) < abs_df
        break
    end
    k=k+1;
end
disp('-------------------')
disp('Results:')
k
disp('Optimal solution:')
x_opt=x_kp1
f_min=f(x_opt)

%------------------------------------------
%Definition of f() as local function:
function [f_value]=f(x);
f_value=100*(x(2)-x(1)^2)^2+(1-x(1))^2;

end