%--------------Optimization 5----------------------------
disp('-------------------')
disp('Using fmincon() in Matlab solve the ROP problem')
disp('min_x f(x)')
disp('s.t.')
disp('model: f=100*(x2-x1^2)^2+(1-x1)^2')
disp('constraints:')
disp('-5 <= x1 <= 5') %Variable constraint
disp('-5 <= x2 <= 5') %Variable constraint
%disp('x2 >= x1+1') %Inequality constraint
%----------------------------------------------------------
format compact
clear all
close all
%--------------------------------------------------

%Contraints:
x_lb=[-5,-5]';
x_ub=[5,5]';

%--------------------------------------------------
%fmincon:
x_guess=[-1.9,2]';
Aineq=[]; Bineq=[]; Aeq=[]; Beq=[];

fun_objective_handle = @(x)fun_objective(x);%Local function
fun_constraints_handle = @(x)fun_constraints(x);%Local function
optim_options=optimset('Display','on');
% optim_options=optimset('Algorithm','sqp','Display','on');
[x_opt,fval,exitflag,output,lambda,grad,hessian] =...
fmincon(fun_objective_handle,x_guess,Aineq,Bineq,Aeq,Beq,x_lb,x_ub,...
    fun_constraints_handle,optim_options);

%--------------------------------------------------
%Displaying the optimal solution:
disp('-------------------')
disp('Optimal solution:')
output
fval
x_opt

%--------------------------------------------------
%Applying the optimal solution:
f_min=100*(x_opt(2)-x_opt(1)^2)^2+(1-x_opt(1))^2

%--------------------------------------------------
%Defining local functions:

function f = fun_objective(x)

f=100*(x(2)-x(1)^2)^2+(1-x(1))^2;
end

function [cineq,ceq]=fun_constraints(x)


cineq = [];  % Compute nonlinear inequalities.
cineq =  -x(2)+x(1)+1;   % Compute nonlinear inequalities.
    %Inequality constraint: x2 >= x1+1
ceq = [];   % Compute nonlinear equalities.
end