%-------------Systems theory---------------------------------------------
% 2 Using CST: Stability analysis and simulation of transfer function
H1=tf(1,[1,1])
pole1=pole(H1)
pzmap(H1); 
Tf=10;impulse(H1,Tf);
step(H1,Tf)
H2=tf([-1,1],[1,1]); 
pole2=pole(H2);
pzmap(H2);
impulse(H2,Tf);
step (H2,Tf);
H3=tf(1,[-1,1]); 
pole3=pole(H3);
pzmap(H3);
Tf3=20;impulse(H3,Tf3);
step(H3,Tf3);

H4=tf(1,[1,0,-1]);
pole4=pole(H4);
pzmap(H4);
impulse(H4);
step(H4);

H5=tf(1,[1,0]);
pole5=pole(H5);
pzmap(H5);
Tf5=10;impulse(H5,Tf5);
step(H5,Tf5);

H6=tf(1,[1,0,0,0]);
pole6=pole(H6);
pzmap(H6);
Tf6=10;impulse(H6,Tf6);
step(H6,Tf6);

H7=tf(1,[1,1],'InputDelay',1);
pole7=pole(H7);
pzmap(H7);
Tf7=10;impulse(H7,Tf7);
step(H7,Tf7);

H8=tf(-1,[1,1]);
pole8=pole(H8);
pzmap(H8);
Tf8=10;impulse(H8,Tf8);
step(H8,Tf8);

H9=tf(1,[1,1,1]);
pole9=pole(H9);
pzmap(H9);
Tf9=20;impulse(H9,Tf9);
step(H9,Tf9);

H10=tf(1,[1,0,1])
pole10=pole(H10);
pzmap(H10);
Tf10=20;impulse(H10,Tf10);
step(H10,Tf10);

H11=tf(1,[1,1,0]);
pose11=pole(H11);
pzmap(H11);
Tf11=20; impulse(H11,Tf11)
step(H11)
% 3 Stability analysis and simulation of a state space model.
A=[0,1;0,-2];B=[0;1];C=[0,0]; D=[0];
pole3a=eig(A);
ss1=ss(A,B,C,D);
x0=[1,1];u0=2; %initial condition
initial(ss1,x0)
s=tf('s');I=eye(2);
tf_u_y=C*inv(s*I-A)*B+D
% 4 tuning and simulation of a feedback control system
Hpm=tf(1,[1,0])
Kp=1.5;Ti=0.05;
s=tf('s');
Hc=Kp+Kp/(Ti*s)
L=feedback(Hpm,Hc,-1)
step(L,10)
%%%% the ultimate gain Kpu=1.5, period Pu=1.2, then PI controller according
%%%% to Z-Z method is Kp=0.45*Kpu=0.68;Ti=Pu/1.2=1
Kpzz=0.68;Tizz=1;
Hczz=Kpzz+Kpzz/(Tizz*s);
Lzz=feedback(Hpm,Hczz)
pzmap(Lzz);
Tsys=feedback(ss(Hpm*Hczz),1)
step(Tsys,20);
% 5. Discretization
Csys=ss(A,B,C,D);
Ts=0.1; 
Dsys=c2d(Csys,Ts,'Zoh');
[Ad,Bd,Cd,Dd,Ts]=ssdata(Dsys);
Deigenvalues=eig(Ad);
% Symbolic linearization with matlab symbolic toolbox
clear all;close all; clc;
%- state variables
syms h1 h2 u1 u2 y1 y2 
%- parameters
syms A1 Kp Kv1 rho g h1 G A2 Kv2 
%- state vectors
h=[h1;h2];
u=[u1;u2];
y=[y1;y2];
%- nonlinear system f1,f2
f1=1/A1*(Kp*u1-Kv1*sqrt(rho*g*h1/G))
f2=1/A2*(Kv1*sqrt(rho*g*h1/G)-Kv2*u2*sqrt(rho*g*h2/G))
g1=h1;
g2=h2;
F=[f1;f2];
G=[g1;g2];
%- compute character matrix
A.linear=jacobian(F,h);
B.linear=jacobian(F,u);
C.linear=jacobian(G,h);
D.linear=jacobian(G,u);
A.linear
B.linear
C.linear
D.linear



